package by.bs.gefdemo;

import java.awt.Color;

import java.io.Serializable;

import java.util.Hashtable;
import java.util.Vector;

import org.tigris.gef.base.Layer;
import org.tigris.gef.demo.PortData;
import org.tigris.gef.graph.presentation.NetNode;
import org.tigris.gef.presentation.FigNode;
import org.tigris.gef.presentation.FigRRect;
import org.tigris.gef.presentation.FigRect;

/**
 *  Computer Node
 *
 *@author     S.Berdachuk
 *@created    Dec 2003.
 */
public class ComputerNode extends NetNode
         implements Serializable {

    /**
     *  Constructor for the ComputerNode object
     */
    public ComputerNode() { }



    /**
     *  Gets the id attribute of the PrinterNode object
     *
     *@return    The id value
     */
    public String getId() {
        return toString();
    }


    /**
     *@return   Hub String representation
     */
    public String toString() {
        return getId();
    }


    /**
     *  Description of the Method
     *
     *@param  args  Description of the Parameter
     */
    public void initialize(Hashtable args) {
        addPort(fDataPort = new PortData(this));
    }


    /**
     *  Printer draw presentation
     *
     *@param  lay  layer
     *@return      Description of the Return Value
     */
    public FigNode makePresentation(Layer lay) {
        org.tigris.gef.presentation.Fig obj1 =
                new FigRect(0, -30, 60, 60, Color.black, Color.lightGray);
        org.tigris.gef.presentation.Fig obj2 =
                new FigRect(5, -25, 50, 40, Color.black, Color.white);

        org.tigris.gef.presentation.Fig obj3 =
                new FigRect(5, 30, 50, 5, Color.black, Color.lightGray);
        org.tigris.gef.presentation.Fig light =
                new FigRect(50, 20, 5, 5, Color.black, Color.green);

        FigRRect dataPort =
                new FigRRect(-8, 10, 8, 8, Color.black, Color.black);
        dataPort.setCornerRadius(3);

        Vector objList = new Vector();
        objList.addElement(obj1);
        objList.addElement(obj2);
        objList.addElement(obj3);
        objList.addElement(light);
        objList.addElement(dataPort);
        FigNode figNode = new FigNode(this, objList);
        figNode.bindPort(fDataPort, dataPort);
        return figNode;
    }


    /**
     *  Description of the Field
     */
    protected PortData fDataPort;
}
