package by.bs.gefdemo;


import java.awt.Color;

import java.io.Serializable;

import java.util.Hashtable;
import java.util.Vector;

import org.tigris.gef.base.Layer;
import org.tigris.gef.demo.PortData;
import org.tigris.gef.graph.presentation.NetNode;
import org.tigris.gef.presentation.*;

/**
 *  4 devices hub node
 *
 *@author     S.Berdachuk
 *@created    Dec 2003.
 */
public class Hub4Node extends NetNode
         implements Serializable {

    /**
     *  Constructor for the PrinterNode object
     */
    public Hub4Node() { }


    /**
     *  Gets the number attribute of the Hub4Node object
     *
     *@return    The number value
     */
    public int getNumber() {
        return idNo;
    }


    /**
     *  Gets node id
     *
     *@return    The id value
     */
    public String getId() {
        return " N" + idNo;
    }



    /**
     *  initialization
     *
     *@param  args  
     */
    public void initialize(Hashtable args) {
        addPort(fDataPort0 = new PortData(this));
        addPort(fDataPort1 = new PortData(this));
        addPort(fDataPort2 = new PortData(this));
        addPort(fDataPort3 = new PortData(this));
        addPort(fDataPort4 = new PortData(this));
        idNo = fNextNumber++;
    }


    /**
     *  Get FigNode representation of Hub
     *
     *@param  lay  layer
     *@return      FigNode
     */
    public FigNode makePresentation(Layer lay) {
        Vector objList = new Vector();

        org.tigris.gef.presentation.Fig obj1 =
                new FigRect(0, 0, 56, 20, Color.black, Color.lightGray);
        org.tigris.gef.presentation.Fig obj2 =
                new FigRect(50, 10, 4, 4, Color.black, Color.green);

        FigRRect dataPort0 =
                new FigRRect(32, -8, 8, 8, Color.black, Color.black);
                
        FigRRect dataPort1 =
                new FigRRect(8, 20, 8, 8, Color.black, Color.black);
        FigRRect dataPort2 =
                new FigRRect(20, 20, 8, 8, Color.black, Color.black);
        FigRRect dataPort3 =
                new FigRRect(32, 20, 8, 8, Color.black, Color.black);
        FigRRect dataPort4 =
                new FigRRect(44, 20, 8, 8, Color.black, Color.black);

        objList.addElement(obj1);
        objList.addElement(obj2);
        objList.addElement(dataPort0);
        objList.addElement(dataPort1);
        objList.addElement(dataPort2);
        objList.addElement(dataPort3);
        objList.addElement(dataPort4);
        FigNode figNode = new FigNode(this, objList);

        figNode.bindPort(fDataPort0, dataPort0);
        figNode.bindPort(fDataPort1, dataPort1);
        figNode.bindPort(fDataPort2, dataPort2);
        figNode.bindPort(fDataPort3, dataPort3);
        figNode.bindPort(fDataPort4, dataPort4);
        return figNode;
    }

    private PortData fDataPort0;
    private PortData fDataPort1;
    private PortData fDataPort2;
    private PortData fDataPort3;
    private PortData fDataPort4;
    private int idNo;
    static int fNextNumber = 1;
}