package by.bs.gefdemo;

import java.awt.Color;

import java.io.Serializable;

import java.util.Hashtable;
import java.util.Vector;

import org.tigris.gef.base.Layer;
import org.tigris.gef.demo.PortData;
import org.tigris.gef.graph.presentation.NetNode;
import org.tigris.gef.presentation.*;

/**
 *  Printer net node
 *
 *@author     S.Berdachuk
 *@created    Dec 2003.
 */
public class PrinterNode extends NetNode
         implements Serializable {

    /**
     *  Constructor for the PrinterNode object
     */
    public PrinterNode() { }


    /**
     *  Gets the id
     *
     *@return    The id value
     */
    public String getId() {
        return toString();
    }


    /**
     *  initialization
     *
     *@param  args  
     */
    public void initialize(Hashtable args) {        
        addPort(fDataPort = new PortData(this));
    }


    /**
     *  Get FigNode representation of the printer node
     *
     *@param  lay  layer
     *@return      FigNode representation
     */
    public FigNode makePresentation(Layer lay) {
        
        org.tigris.gef.presentation.Fig obj0 =         
          new FigRect(5, -20, 50, 30, Color.black, Color.white);
          
        org.tigris.gef.presentation.Fig obj1 =         
          new FigRect(0, 0, 60, 25, Color.black, Color.lightGray);        
        org.tigris.gef.presentation.Fig obj2 = 
          new FigRect(5, 25, 50, 5, Color.black, Color.lightGray);
        org.tigris.gef.presentation.Fig obj3 = 
          new FigRect(40, 15, 5, 5, Color.black, Color.green);  
        
        FigRRect dataPort =
         new FigRRect(60, 10, 8, 8, Color.black, Color.black);
        dataPort.setCornerRadius(2);
        
        Vector objList = new Vector();
        objList.addElement(obj0);
        objList.addElement(obj1);
        objList.addElement(obj2);
        objList.addElement(obj3);
        objList.addElement(dataPort);
        FigNode figNode = new FigNode(this, objList);
        
        figNode.bindPort(fDataPort, dataPort);
        return figNode;
    }
    
    protected PortData fDataPort;
}